// Solutie 45 puncte Chesca Ciprian 
// backtracking - generare permutari cu repetitie

#include <fstream>
#define amax 10
#define bmax 50

typedef int vector[bmax];

using namespace std;

ifstream f("sumall.in");
ofstream g("sumall.out");

long long n;
vector rez,st;

int nr[amax],r,m[amax],uz[amax],p=0;

void initializare(vector w)
{
  w[0] = 1; w[w[0]] = 0;
}


void Add(vector A, vector B)
/* A <- A+B */
{ int i,T=0;

  if (B[0]>A[0])
    { for (i=A[0]+1;i<=B[0];) A[i++]=0;
      A[0]=B[0];
    }
    else for (i=B[0]+1;i<=A[0];) B[i++]=0;
  for (i=1;i<=A[0];i++)
    { A[i]+=B[i]+T;
      T=A[i]/10;
      A[i]%=10;
    }
  if (T) A[++A[0]]=T;
}

void adunare()
{
    st[0]=p;
    Add(rez,st);
}

void permuta(int k)
    {
    int i;
    if (k==p+1) adunare();
        else
        for(i=1;i<=r;i++)
            if (uz[i]<m[i])
            {
            st[k]=nr[i];
            uz[i]++;
            permuta(k+1);
            uz[i]--;
            }
    }


int main()
{

    int i,s;
    long long x;

    // citesc datele de intrare
    f>>n;


    r=0;
    for(i=1;i<=9;i++)
    {
        x=n;
        s=0;
        while (x>0)
           {
           if (x%10==i) s++;
           x=x/10;
           }
        if (s) {nr[++r]=i;m[r]=s;p=p+m[r];}
    }

    initializare(rez);
    permuta(1);


    // afisare rezultat final
    for(i=rez[0];i>=1;i--)
        g<<rez[i];
    g<<"\n";


    f.close();
    g.close();
    return 0;
}
